Subject: Re: Ethernet issue on imx6

From: "Russell King (Oracle)" <[email-masked]>
Date: Thu, 12 Oct 2023 20:39:11 +0100

On Thu, Oct 12, 2023 at 07:34:10PM +0200, Miquel Raynal wrote:
> Hello,
> 
> I've been scratching my foreheads for weeks on a strange imx6
> network issue, I need help to go further, as I feel a bit clueless now.
> 
> Here is my setup :
> - Custom imx6q board
> - Bootloader: U-Boot 2017.11 (also tried with a 2016.03)
> - Kernel : 4.14(.69,.146,.322), v5.10 and v6.5 with the same behavior
> - The MAC (fec driver) is connected to a Micrel 9031 PHY
> - The PHY is connected to the link partner through an industrial cable

"industrial cable" ?

> - Testing 100BASE-T (link is stable)

Would that be full or half duplex?

> The RGMII-ID timings are probably not totally optimal but offer rather
> good performance. In UDP with iperf3:
> * Downlink (host to the board) runs at full speed with 0% drop
> * Uplink (board to host) runs at full speed with <1% drop
> 
> However, if I ever try to limit the bandwidth in uplink (only), the drop
> rate rises significantly, up to 30%:
> 
> //192.168.1.1 is my host, so the below lines are from the board:
> # iperf3 -c 192.168.1.1 -u -b100M
> [  5]   0.00-10.05  sec   113 MBytes  94.6 Mbits/sec  0.044 ms  467/82603 (0.57%)  receiver
> # iperf3 -c 192.168.1.1 -u -b90M
> [  5]   0.00-10.04  sec  90.5 MBytes  75.6 Mbits/sec  0.146 ms  12163/77688 (16%)  receiver
> # iperf3 -c 192.168.1.1 -u -b80M
> [  5]   0.00-10.05  sec  66.4 MBytes  55.5 Mbits/sec  0.162 ms  20937/69055 (30%)  receiver

My setup:

i.MX6DL silicon rev 1.3
Atheros AR8035 PHY
6.3.0+ (no significant changes to fec_main.c)
Link, being BASE-T, is standard RJ45.

Connectivity is via a bridge device (sorry, can't change that as it would
be too disruptive, as this is my Internet router!)

Running at 1000BASE-T (FD):
[ ID] Interval           Transfer     Bitrate         Jitter    Lost/Total Datagrams
[  5]   0.00-10.01  sec   114 MBytes  95.4 Mbits/sec  0.030 ms  0/82363 (0%)  receiver
[  5]   0.00-10.00  sec   107 MBytes  90.0 Mbits/sec  0.103 ms  0/77691 (0%)  receiver
[  5]   0.00-10.00  sec  95.4 MBytes  80.0 Mbits/sec  0.101 ms  0/69060 (0%)  receiver

Running at 100BASE-Tx (FD):
[ ID] Interval           Transfer     Bitrate         Jitter    Lost/Total Datagrams
[  5]   0.00-10.01  sec   114 MBytes  95.4 Mbits/sec  0.008 ms  0/82436 (0%)  receiver
[  5]   0.00-10.00  sec   107 MBytes  90.0 Mbits/sec  0.088 ms  0/77692 (0%)  receiver
[  5]   0.00-10.00  sec  95.4 MBytes  80.0 Mbits/sec  0.108 ms  0/69058 (0%)  receiver

Running at 100bASE-Tx (HD):
[ ID] Interval           Transfer     Bitrate         Jitter    Lost/Total Datagrams
[  5]   0.00-10.01  sec   114 MBytes  95.3 Mbits/sec  0.056 ms  0/82304 (0%)  receiver
[  5]   0.00-10.00  sec   107 MBytes  90.0 Mbits/sec  0.101 ms  1/77691 (0.0013%)  receiver
[  5]   0.00-10.00  sec  95.4 MBytes  80.0 Mbits/sec  0.105 ms  0/69058 (0%)  receiver

So I'm afraid I don't see your issue.

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 80Mbps down 10Mbps up. Decent connectivity at last!